SystemOrganization addCategory: #Croquis!

Object subclass: #Croquis
	instanceVariableNames: 'superclassOfOutputClass correctPluralToSingular outputSystemCategory asksUserToManuallyChooseSuperclassOfOutputClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis'!

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:36'!
asksUserToManuallyChooseSuperclassOfOutputClass
^asksUserToManuallyChooseSuperclassOfOutputClass! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:31'!
asksUserToManuallyChooseSuperclassOfOutputClass: aBoolean 
asksUserToManuallyChooseSuperclassOfOutputClass := aBoolean! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 20:45'!
classesInTheOutputSystemCategory
	^ (((PackageInfo named: self outputSystemCategory) classes) asSortedCollection: [:class1 :class2| class1 name <= class2 name ]) asArray! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:10'!
correctPluralToSingular
^correctPluralToSingular! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 16:13'!
correctPluralToSingular: aBoolean
correctPluralToSingular := aBoolean! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/1/2012 14:57'!
createClassFromClipboardText
self createClassFromNoun: ((Clipboard clipboardText) asString)! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/1/2012 20:43'!
createClassFromNoun: aString
	| words className |
	outputSystemCategory isString
		ifFalse: [ self error: 'Need to set outputSystemCategory to continue.' ].
	words := aString subStrings: ' -	.,''"!!?()'.
	self correctPluralToSingular
		ifTrue: [ 
			(words last endsWith: 's')
				ifTrue: [ words at: words size modify: [ :str | str allButLast ] ] ].
	className := (String
		streamContents: [ :stream | (words collect: #capitalized) do: [ :each | stream nextPutAll: each ] ]) asSymbol.
	(Smalltalk hasClassNamed: className)
		ifTrue: [ 
			^ UIManager default
				inform:
					className surroundedBySingleQuotes
						,
							' already exists.
Process aborted.' ].
	self asksUserToManuallyChooseSuperclassOfOutputClass
		ifTrue: [ 
			| classes selectedIndex |
			classes := self classesInTheOutputSystemCategory , {Object}.
			selectedIndex := UIManager default chooseFrom: classes title: 'Superclass of ' , className.
			selectedIndex = 0
				ifFalse: [ self superclassOfOutputClass: (classes at: selectedIndex) ] ].
	self superclassOfOutputClass
		subclass: className
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self outputSystemCategory! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/1/2012 17:02'!
createClassFromUser
	| noun |
	noun := UIManager default request: 'plain english noun to create class:'.
	noun ifNil: [^self].
	noun isEmpty ifTrue: [^self inform: 'You did not enter anything.
Aborting process.'].
	self createClassFromNoun: noun.! !

!Croquis methodsFor: 'initialize-release' stamp: 'HwaJong 12/1/2012 15:32'!
initialize 
super initialize.
superclassOfOutputClass := Object.
correctPluralToSingular := false.
outputSystemCategory := nil.
asksUserToManuallyChooseSuperclassOfOutputClass := false.! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:13'!
outputSystemCategory
^outputSystemCategory! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:16'!
outputSystemCategory: aString 
	outputSystemCategory := aString! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 14:51'!
superclassOfOutputClass
^superclassOfOutputClass! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 14:51'!
superclassOfOutputClass: aClass
superclassOfOutputClass := aClass! !
